#pragma title ("CW MQM examples - cw_tempq_put1_get.c")

/*-----------------------------------------------------+
| MVS (OS/390) only pragma(s).                         |
+-----------------------------------------------------*/

#ifdef MVS
#pragma runopts(ENV(MVS),PLIST(MVS),NOEXECOPS,\
NOTEST(NONE,INSPICD,PROMPT) )

#pragma csect(code,"CW_MAIN")
#pragma csect(static,"CW_WS")

#pragma comment( copyright , "Roger Lacroix" )
#endif

#pragma subtitle( "Load module eye-catchers" )

/*-----------------------------------------------------+
| Program build time eye-catchers for executable.      |
+-----------------------------------------------------*/

static const char * EYECATCHER_EyeCatcher  = "cw_tempq_put1_get ";
static const char * EYECATCHER_Version     = "01.00.00" ;
static const char * EYECATCHER_Datestamp   = __DATE__ ;
static const char * EYECATCHER_Timestamp   = __TIME__ ;
static const char * EYECATCHER_Filename    = __FILE__ ;

#pragma subtitle ("Change History")
#pragma page ()

      /*----------------------------------------------------+
      | CHANGE HISTORY for CW MQM Example code.             |
      | Change codes are written in column 73-78.           |
      |-----------------------------------------------------|
      | Date       Change-id   Produced     SCR number.     |
      | yyyymmdd               Version.                     |
      |                        rr.ss.uu                     |
      | Reason                                              |
      |-----------------------------------------------------|
      | 19980601   R. Lacroix  01.00.00                     |
      | Birth.                                              |
      |                                                     |
      |                                                     |
      +----------------------------------------------------*/

#pragma subtitle ("Program Description")
#pragma page ()

      /*----------------------------------------------------+
      | Program:  CW MQM Examples                           |
      |                                                     |
      | Purpose:  Examples show show the use of CW MQM      |
      |           common code.                              |
      |                                                     |
      +----------------------------------------------------*/

#pragma subtitle ("Include Files")
#pragma page ()

      /*----------------------------------------------------+
      | System include files.                               |
      +----------------------------------------------------*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>

      /*----------------------------------------------------+
      | MQM include files.                                  |
      +----------------------------------------------------*/

#include "cmqc.h"           // general MQM definitions

      /*----------------------------------------------------+
      | CW include files.                                   |
      +----------------------------------------------------*/

#include "cwmqm.h"         // common CW MQM definitions

      /*----------------------------------------------------+
      | general purpose defines.                            |
      +----------------------------------------------------*/

#define  DEFAULT_QUEUE_MGR_NAME  \
                   "MQT1                                            "
#define  DEFAULT_QUEUE_NAME      \
                   "SYSTEM.DEFAULT.LOCAL.QUEUE                      "
#define  DEFAULT_MOCWL_NAME      \
                   "SYSTEM.DEFAULT.MOCWL.QUEUE                      "
#define  BLANK_48  "                                                "


#pragma subtitle ("Global Areas")
#pragma page ()

      /*----------------------------------------------------+
      | Global Areas.                                       |
      +----------------------------------------------------*/

   MQHCONN           LocalMqmHandle;


#pragma subtitle ("Mainline")
#pragma page ()

      /*----------------------------------------------------+
      | Routine : Examples                                  |
      |                                                     |
      | Purpose:                                            |
      | The mainline of this program is to should how       |
      | to use the common CW MQM routines.                  |
      |                                                     |
      | Input:                                              |
      |  None.                                              |
      |                                                     |
      | Output:                                             |
      |  None.                                              |
      |                                                     |
      | Messages:                                           |
      |  None.                                              |
      |                                                     |
      | Return codes:                                       |
      |  CW_RC_OK     - terminated successfully.            |
      |  CW_RC_FAILED - terminating with error.             |
      |                                                     |
      | Abend Codes:                                        |
      |  None.                                              |
      |                                                     |
      | Called Routines:                                    |
      |                                                     |
      +----------------------------------------------------*/

extern int main ( )
{
   /*------------------------------------------------------+
   | Variable declarations.                                |
   +------------------------------------------------------*/

   auto   CW_RC_T    CwRC;         /* function return code        */

   auto   QUEUE_NAME  QueueMgrName, ReplyToQueueMgr;

   auto   QUEUE_NAME  QueueName, ReplyToQueue;

   auto   MQHOBJ      QueueHandle;

   auto   QUEUE_NAME  ReplyToQMgrName;

   auto   QUEUE_NAME  ReplyToQueueName;

   auto   char       *ReceiveMsgPtr, *SendMsgPtr;

   auto   int         ReceiveMsgSize, SendMsgSize, MessageLength;

   /*------------------------------------------------------+
   | Constant definitions.                                 |
   +------------------------------------------------------*/

   /*------------------------------------------------------+
   | Code section                                          |
   +------------------------------------------------------*/

   CwRC = CW_RC_OK;        /* Assume that the return code is OK. */

   printf("Starting...\n");

   /*-------------------------------------------------------+
   | Set the name of the queue manager.                     |
   +-------------------------------------------------------*/

   memcpy( QueueMgrName,
           DEFAULT_QUEUE_MGR_NAME,
           sizeof(QueueMgrName) );

   /*------------------------------------------------------+
   | Make sure we have a connection to MQM.                |
   +------------------------------------------------------*/

   CwRC = CW_ConnectToMqm( QueueMgrName );

   /*-------------------------------------------------------+
   | We want to the queue name to begin with FRED.          |
   +-------------------------------------------------------*/

   memcpy( QueueName,
           "FRED.*",
           sizeof(QueueName) );

   /*---------------------------------------------------+
   | Create and Open a temporary dynamic queue.         |
   | We'll just use the system model queue.             |
   | The function will return with QMgr and Queue       |
   | name filled in.                                    |
   +---------------------------------------------------*/

   CwRC = CW_OpenMqmQueue( QueueMgrName,
                           QueueName,
                           DEFAULT_MOCWL_NAME,
                           &(QueueHandle),
                           MQOO_INPUT_EXCLUSIVE );

   /*-------------------------------------------------------+
   | Need space for out bound message.                      |
   +-------------------------------------------------------*/

   SendMsgSize = 2048;

   SendMsgPtr = malloc( SendMsgSize );  /* allocate 2kb of memory */

   strcpy( SendMsgPtr,
           "Here's a test message from CW_tempq_put1_get. - "\
           "Please me back a reply. Thanks.                  " );

   /*-------------------------------------------------------+
   | Fillin the ReplyTo queue manager name and queue name.  |
   | We DO want a message sent back to our temp. Dynamic Q. |
   +-------------------------------------------------------*/

   memcpy( ReplyToQMgrName,
           QueueMgrName,
           sizeof(ReplyToQMgrName) );

   memcpy( ReplyToQueueName,
           QueueName,
           sizeof(ReplyToQueueName) );

   /*-------------------------------------------------------+
   | Send the message using MQPUT1.                         |
   +-------------------------------------------------------*/

   CwRC = CW_SendOneMqmMessage( ReplyToQueueMgr,
                                ReplyToQueue,
                                ReplyToQMgrName,
                                ReplyToQueueName,
                                SendMsgPtr,
                                SendMsgSize );

   /*-------------------------------------------------------+
   | Allocate room for the incoming message.                |
   +-------------------------------------------------------*/

   ReceiveMsgSize = 1024;

   ReceiveMsgPtr = malloc( ReceiveMsgSize );

   /*-------------------------------------------------------+
   | Send the message.                                      |
   +-------------------------------------------------------*/

   CwRC = CW_GetMqmMessage( QueueHandle,
                            ReceiveMsgPtr,
                            ReceiveMsgSize,
                            20,             /* wait 20 seconds */
                            &(MessageLength),
                            NULL );

   printf( "Buffer size=%d - %s\n", MessageLength, ReceiveMsgPtr );


   /*-------------------------------------------------------+
   | Close the queue.                                       |
   +-------------------------------------------------------*/

   CwRC = CW_CloseMqmQueue( &(QueueHandle) );

   /*-------------------------------------------------------+
   | Disconnect from the queue manager.                     |
   +-------------------------------------------------------*/

   CwRC = CW_DisconnectFromMqm( );

   /*-------------------------------------------------------+
   | Time to lose the memory.                               |
   +-------------------------------------------------------*/

   free( ReceiveMsgPtr );
   free( SendMsgPtr );

   return ( CwRC );
}

#pragma subtitle ("Function Include Files")
#pragma page ()

   /*------------------------------------------------------+
   | Include the MQM routines.                             |
   +------------------------------------------------------*/

#include "cwmqm.c"

